Bug 595196 - gcj does not produce the proper console executable
gcj does not produce the proper console executable
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
12
All Linux
low Severity medium
: ---
: ---
Assigned To: Andrew Haley
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-23 20:11 EDT by Adam
Modified: 2010-12-03 09:25 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-12-03 09:25:58 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Adam 2010-05-23 20:11:32 EDT
Description of problem:

A program from *Curach's Java SE6* book does not compile correctly.

Version-Release number of selected component (if applicable):

$ gcj --version
gcj (GCC) 4.4.3 20100127 (Red Hat 4.4.3-4)
Copyright (C) 2010 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


How reproducible:

Easy

Steps to Reproduce:
1.  Enter the following code through your favorite editor and save it:

import java.util.Scanner;

public class InvoiceApp {
	public static void main(String[] args)
	{
		// Welcome the user to the program
		System.out.println("Welcome to the InvoiceTotal Calculator");
		System.out.println();
		
		// create a Scanner object named sc
		Scanner sc = new Scanner (System.in);
		
		// perform invoice calculations until choice isn't equal to "Y" or "y"
		String choice = "y";
		while (choice.equalsIgnoreCase("y")) {
			// get the invoice subtotal from the user
			System.out.print("Enter subtotal:   ");
			double subtotal = sc.nextDouble();
			
			// calculate the discount amount and total
			double discountPercent = 0.0;
			if (subtotal >= 200)
				discountPercent = .2;
			else if (subtotal >= 100)
				discountPercent = .1;
			else discountPercent = 0.0;
			
			double discountAmount = subtotal * discountPercent;
			double total = subtotal - discountAmount;
			
			// display the discount amount and total
			String message = "Discount percent: " + discountPercent + "\n"
			               + "Discount amount:  " + discountAmount + "\n"
			               + "Invoice total:    " + total + "\n";
			System.out.println(message);
			
			// see is user wants to continue
			System.out.print("Continue? (y/n): ");
			choice = sc.next();
			System.out.println();
		}
	}
}


(I used Eclipse, so I ended up with a src and bin folder for my project).


2.  Use javac to compile this source.  Test it and observe the expected program behavior.  

3.  Now, use the following command to compile the source into a stand-alone executable:

$ gcj --main=InvoiceApp -o bin/InvoiceApp src/InvoiceApp.java

Observe that no error or warnings are thrown in the compile.
  
Actual results:

When the compiled object is run, the program is stopped after the "Welcome" message is displayed and is waiting for input.  Pressing <enter> encourages the program to continue.  Then, when entering a whole number, the program throws an exception:

$ bin/InvoiceApp
Welcome to the InvoiceTotal Calculator
<enter>

Enter subtotal:   100<enter>
Exception in thread "main" java.util.InputMismatchException: "" is not a double
   at java.util.Scanner.myNextDouble(libgcj.so.10)
   at java.util.Scanner.nextDouble(libgcj.so.10)
   at InvoiceApp.main(InvoiceApp)

Expected results:

The compiled program should behave as the javac compiled version.

Additional info:
Comment 1 Bug Zapper 2010-11-03 10:20:04 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2010-12-03 09:25:58 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.